﻿using System;
using Telerik.WinControls.UI;

namespace ProgressCellElement
{
    public class GridProgressCellElement : GridDataCellElement
    {
        private RadProgressBarElement progressBar;

        public GridProgressCellElement(GridViewColumn column, GridRowElement row)
            : base(column, row)
        {

        }

        protected override Type ThemeEffectiveType
        {
            get
            {
                return typeof(GridDataCellElement);
            }
        }

        public override bool IsEditable
        {
            get
            {
                return false;
            }
        }

        protected override void CreateChildElements()
        {
            base.CreateChildElements();
            this.progressBar = new RadProgressBarElement();
            this.progressBar.StretchVertically = true;
            this.progressBar.StretchHorizontally = true;
            this.Children.Add(this.progressBar);
        }

        public override bool IsCompatible(GridViewColumn data, object context)
        {
            return data.Name == "Progress" && context is GridDataRowElement;
        }

        protected override void SetContentCore(object value)
        {
            this.progressBar.Value1 = Convert.ToInt32(value);
        }
    }
}
